/*
Gtk+ogltk - Gtk+ OpenGL Toolkit

Copyright (C) 2003 SandorLabs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Contact :
    John Kiss - jkiss@sandorapplications.com


*/
#if !defined(GLT_COLOR_H)
#define GLT_COLOR_H

#include <glib.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _glt_color           gltColor;

struct _glt_color
{
    gfloat      red;
    gfloat      green;
    gfloat      blue;    
    gfloat      alpha;
};



gltColor*           glt_color_new(void);
gltColor*           glt_color_new_color(gfloat red, gfloat green, gfloat blue, gfloat alpha);

gboolean            glt_color_destroy(gltColor *color);

gboolean            glt_color_set_gl(gltColor *color, gfloat red, gfloat green, gfloat blue, gfloat alpha);

gboolean            glt_color_draw(gltColor *color);

#define             glt_color_get_red(c)            (gfloat)(c->red)
#define             glt_color_get_green(c)          (gfloat)(c->green)
#define             glt_color_get_blue(c)           (gfloat)(c->blue)
#define             glt_color_get_alpha(c)          (gfloat)(c->alpha)

#define             glt_color_set_red_gl(c,v)       c->red = v
#define             glt_color_set_green_gl(c,v)     c->green = v
#define             glt_color_set_blue_gl(c,v)      c->blue = v
#define             glt_color_set_alpha_gl(c,v)     c->alpha = v


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* GLT_COLOR_H */
