/*
Gtk+ogltk - Gtk+ OpenGL Toolkit

Copyright (C) 2003 SandorLabs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Contact :
    John Kiss - jkiss@sandorapplications.com


*/
#if !defined(GLO_BOX_H)
#define GLO_BOX_H

#include "glib.h"
#include "ogltk/globject.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define	GLO_TYPE_BOX		            ( glo_box_get_type() )
#define GLO_BOX(object)		            (OGLTK_CHECK_CAST ((object),      GLO_TYPE_BOX, glo_box))
#define GLO_BOX_CLASS(klass)		    (OGLTK_CHECK_CLASS_CAST ((klass), GLO_TYPE_BOX, glo_box_class))
#define GLO_IS_BOX(object)		        (OGLTK_CHECK_TYPE ((object),      GLO_TYPE_BOX))
#define GLO_IS_BOX_CLASS(klass)	        (OGLTK_CHECK_CLASS_TYPE ((klass), GLO_TYPE_BOX))
#define	GLO_BOX_GET_CLASS(object)       (OGLTK_CHECK_GET_CLASS ((object), GLO_TYPE_BOX, glo_box_class))

typedef struct _glo_box	                glo_box;
typedef struct _glo_box_class           glo_box_class;

struct _glo_box
{
    GLobject                parent_instance;
    gfloat                  length;
    gfloat                  height;
    gfloat                  width;
};

struct _glo_box_class
{
  GLobject_class             parent_class;

};

GType                       glo_box_get_type(void);

GLobject*                   glo_box_new(gfloat length, gfloat height, gfloat width);

gboolean                    glo_box_set_length(glo_box *box, gfloat length);
gfloat                      glo_box_get_length(glo_box *box);

gboolean                    glo_box_set_height(glo_box *box, gfloat height);
gfloat                      glo_box_get_height(glo_box *box);

gboolean                    glo_box_set_width(glo_box *box, gfloat width);
gfloat                      glo_box_get_width(glo_box *box);


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* GLO_BOX_H */ 

