/*
Gtk+ogltk - Gtk+ OpenGL Toolkit

Copyright (C) 2003 SandorLabs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Contact :
    John Kiss - jkiss@sandorapplications.com


*/
#if !defined(GLO_CUBE_H)
#define GLO_CUBE_H

#include "glib.h"
#include "ogltk/globject.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define	GLO_TYPE_CUBE		            ( glo_cube_get_type() )
#define GLO_CUBE(object)		        (OGLTK_CHECK_CAST ((object),      GLO_TYPE_CUBE, glo_cube))
#define GLO_CUBE_CLASS(klass)		    (OGLTK_CHECK_CLASS_CAST ((klass), GLO_TYPE_CUBE, glo_cube_class))
#define GLO_IS_CUBE(object)		        (OGLTK_CHECK_TYPE ((object),      GLO_TYPE_CUBE))
#define GLO_IS_CUBE_CLASS(klass)	    (OGLTK_CHECK_CLASS_TYPE ((klass), GLO_TYPE_CUBE))
#define	GLO_CUBE_GET_CLASS(object)      (OGLTK_CHECK_GET_CLASS ((object), GLO_TYPE_CUBE, glo_cube_class))

typedef struct _glo_cube	            glo_cube;
typedef struct _glo_cube_class          glo_cube_class;

struct _glo_cube
{
    GLobject                parent_instance;
    gfloat                  size;
};

struct _glo_cube_class
{
  GLobject_class             parent_class;

};

GType                       glo_cube_get_type(void);

GLobject*                   glo_cube_new(gfloat size);

gboolean                    glo_cube_set_size(glo_cube *cube, gfloat size);    
gfloat                      glo_cube_get_size(glo_cube *cube);    

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* GLO_CUBE_H */ 

