/*
Gtk+ogltk - Gtk+ OpenGL Toolkit

Copyright (C) 2003 SandorLabs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Contact :
    John Kiss - jkiss@sandorapplications.com


*/
#if !defined(GLO_GEAR_H)
#define GLO_GEAR_H
#include "ogltk/globject.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define	GLO_TYPE_GEAR		                ( glo_gear_get_type() )
#define GLO_GEAR(object)	                (OGLTK_CHECK_CAST ((object),      GLO_TYPE_GEAR, glo_gear))
#define GLO_GEAR_CLASS(klass)		        (OGLTK_CHECK_CLASS_CAST ((klass), GLO_TYPE_GEAR, glo_gear_class))
#define GLO_IS_GEAR(object)	                (OGLTK_CHECK_TYPE ((object),      GLO_TYPE_GEAR))
#define GLO_IS_GEAR_CLASS(klass)            (OGLTK_CHECK_CLASS_TYPE ((klass), GLO_TYPE_GEAR))
#define	GLO_GEAR_GET_CLASS(object)          (OGLTK_CHECK_GET_CLASS ((object), GLO_TYPE_GEAR, glo_gear_class))

typedef struct _glo_gear	                glo_gear;
typedef struct _glo_gear_class              glo_gear_class;

struct _glo_gear
{
    GLobject             parent_instance;

    /* Properties */
    gfloat              inner_radius;
    gfloat              outer_radius;
    gfloat              width;
    gint                teeth;
    gfloat              tooth_depth;    
};

struct _glo_gear_class
{
  GLobject_class        parent_class;

};

GType                       glo_gear_get_type(void);

GLobject*                   glo_gear_new(gfloat inner_radius, gfloat outer_radius, gfloat width, gint teeth, gfloat tooth_depth);

/* Property Control Methods */
gboolean                    glo_gear_set_inner_radius(glo_gear *gear, gfloat inner);
gboolean                    glo_gear_set_outer_radius(glo_gear *gear, gfloat outer);
gboolean                    glo_gear_set_width(glo_gear *gear, gfloat width);
gboolean                    glo_gear_set_teeth(glo_gear *gear, gint teeth);
gboolean                    glo_gear_set_tooth_depth(glo_gear *gear, gfloat depth);

gfloat                      glo_gear_get_inner_radius(glo_gear *gear);
gfloat                      glo_gear_get_outer_radius(glo_gear *gear);
gfloat                      glo_gear_get_width(glo_gear *gear);
gint                        glo_gear_get_teeth(glo_gear *gear);
gfloat                      glo_gear_get_tooth_depth(glo_gear *gear);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* GLO_GEAR_H */ 

