/*
Gtk+ogltk - Gtk+ OpenGL Toolkit

Copyright (C) 2003 SandorLabs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Contact :
    John Kiss - jkiss@sandorapplications.com


*/
#if !defined(GLO_GLUQUAD_H)
#define GLO_GLUQUAD_H

#include "glib.h"
#include "ogltk/globject.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define	GLO_TYPE_GLUQUAD		            ( glo_gluquad_get_type() )
#define GLO_GLUQUAD(object)		            (OGLTK_CHECK_CAST ((object),      GLO_TYPE_GLUQUAD, glo_gluquad))
#define GLO_GLUQUAD_CLASS(klass)		    (OGLTK_CHECK_CLASS_CAST ((klass), GLO_TYPE_GLUQUAD, glo_gluquad_class))
#define GLO_IS_GLUQUAD(object)		        (OGLTK_CHECK_TYPE ((object),      GLO_TYPE_GLUQUAD))
#define GLO_IS_GLUQUAD_CLASS(klass)	        (OGLTK_CHECK_CLASS_TYPE ((klass), GLO_TYPE_GLUQUAD))
#define	GLO_GLUQUAD_GET_CLASS(object)       (OGLTK_CHECK_GET_CLASS ((object), GLO_TYPE_GLUQUAD, glo_gluquad_class))

typedef struct _glo_gluquad	                glo_gluquad;
typedef struct _glo_gluquad_class           glo_gluquad_class;


typedef enum
{
    GLUQUAD_DRAW_NONE,

    GLUQUAD_DRAW_POINT          = GLU_POINT,
    GLUQUAD_DRAW_LINE           = GLU_LINE,
    GLUQUAD_DRAW_FILL           = GLU_FILL,
    GLUQUAD_DRAW_SILHOUETTE     = GLU_SILHOUETTE,
    
    GLUQUAD_DRAW_LAST           = 0xFFFFFFFF
    
}eGLUQuadDrawStyle;

typedef enum
{
    /* This is the order in which values are defined in glu.h */
    GLUQUAD_NORMAL_SMOOTH       = GLU_SMOOTH,
    GLUQUAD_NORMAL_FLAT         = GLU_FLAT,
    GLUQUAD_NORMAL_NONE         = GLU_NONE,
    
    GLUQUAD_NORMAL_LAST         = 0xFFFFFFFF

}eGLUQuadNormal;

typedef enum
{
    GLUQUAD_ORIENTATION_NONE,
    
    GLUQUAD_ORIENTATION_OUTSIDE = GLU_OUTSIDE,
    GLUQUAD_ORIENTATION_INSIDE  = GLU_INSIDE,
    
    GLUQUAD_ORIENTATION_LAST    = 0xFFFFFFFF

}eGLUQuadOrientation;


struct _glo_gluquad
{
    GLobject                parent_instance;
    
    eGLUQuadDrawStyle       drawstyle;
    eGLUQuadNormal          normal;
    eGLUQuadOrientation     orientation;
    gboolean                texture;
    
    GLUquadricObj           *quad_obj;
};

struct _glo_gluquad_class
{
  GLobject_class             parent_class;
};

GType                       glo_gluquad_get_type(void);


gboolean                    glo_gluquad_set_draw_style(glo_gluquad *quad, eGLUQuadDrawStyle style);
gboolean                    glo_gluquad_set_normal(glo_gluquad *quad, eGLUQuadNormal normal);
gboolean                    glo_gluquad_set_orientation(glo_gluquad *quad, eGLUQuadOrientation orient);
gboolean                    glo_gluquad_set_texture(glo_gluquad *quad, gboolean enable);

eGLUQuadDrawStyle           glo_gluquad_get_draw_style(glo_gluquad *quad);
eGLUQuadNormal              glo_gluquad_get_normal(glo_gluquad *quad);
eGLUQuadOrientation         glo_gluquad_get_orientation(glo_gluquad *quad);
gboolean                    glo_gluquad_get_texture(glo_gluquad *quad);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* GLO_GLUQUAD_H */ 

