/*
Gtk+ogltk - Gtk+ OpenGL Toolkit

Copyright (C) 2003 SandorLabs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Contact :
    John Kiss - jkiss@sandorapplications.com


*/
#if !defined(GLU_CYLINDER_H)
#define GLU_CYLINDER_H

#include "glib.h"
#include "ogltk/glo_gluquad.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define	GLU_TYPE_CYLINDER		            ( glu_cylinder_get_type() )
#define GLU_CYLINDER(object)		        (OGLTK_CHECK_CAST ((object),      GLU_TYPE_CYLINDER, glu_cylinder))
#define GLU_CYLINDER_CLASS(klass)		    (OGLTK_CHECK_CLASS_CAST ((klass), GLU_TYPE_CYLINDER, glu_cylinder_class))
#define GLU_IS_CYLINDER(object)		        (OGLTK_CHECK_TYPE ((object),      GLU_TYPE_CYLINDER))
#define GLU_IS_CYLINDER_CLASS(klass)	    (OGLTK_CHECK_CLASS_TYPE ((klass), GLU_TYPE_CYLINDER))
#define	GLU_CYLINDER_GET_CLASS(object)      (OGLTK_CHECK_GET_CLASS ((object), GLU_TYPE_CYLINDER, glu_cylinder_class))

typedef struct _glu_cylinder	            glu_cylinder;
typedef struct _glu_cylinder_class          glu_cylinder_class;

typedef enum
{
    GLU_CYLINDER_CAP_NONE,
    
    GLU_CYLINDER_CAP_TOP,
        
    GLU_CYLINDER_CAP_LAST

}eGluCylinderCap;

struct _glu_cylinder
{
    glo_gluquad             parent_instance;
    gdouble                 base;
    gdouble                 top;
    gdouble                 height;
    gint                    slices;
    gint                    loops;
    eGluCylinderCap         cap;
    
};

struct _glu_cylinder_class
{
    glo_gluquad_class       parent_class;
};

GType                       glu_cylinder_get_type(void);

GLobject*                   glu_cylinder_new(gdouble base, gdouble top, gdouble height, gint slices, gint loops);

gboolean                    glu_cylinder_set_base(glu_cylinder *cylinder, gdouble base);
gboolean                    glu_cylinder_set_top(glu_cylinder *cylinder, gdouble top);
gboolean                    glu_cylinder_set_height(glu_cylinder *cylinder, gdouble height);
gboolean                    glu_cylinder_set_slices(glu_cylinder *cylinder, gint slices);
gboolean                    glu_cylinder_set_loops(glu_cylinder *cylinder, gint loops);
gboolean                    glu_cylinder_set_cap(glu_cylinder *cylinder, eGluCylinderCap cap);

gdouble                     glu_cylinder_get_base(glu_cylinder *cylinder);
gdouble                     glu_cylinder_get_top(glu_cylinder *cylinder);
gdouble                     glu_cylinder_get_height(glu_cylinder *cylinder);
gint                        glu_cylinder_get_slices(glu_cylinder *cylinder);
gint                        glu_cylinder_get_loops(glu_cylinder *cylinder);
eGluCylinderCap             glu_cylinder_get_cap(glu_cylinder *cylinder);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* GLU_CYLINDER_H */ 

