/*
Gtk+ogltk - Gtk+ OpenGL Toolkit

Copyright (C) 2003 SandorLabs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Contact :
    John Kiss - jkiss@sandorapplications.com


*/
#if !defined(GLU_DISK_H)
#define GLU_DISK_H

#include "glib.h"
#include "ogltk/glo_gluquad.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define	GLU_TYPE_DISK		            ( glu_disk_get_type() )
#define GLU_DISK(object)		        (OGLTK_CHECK_CAST ((object),      GLU_TYPE_DISK, glu_disk))
#define GLU_DISK_CLASS(klass)		    (OGLTK_CHECK_CLASS_CAST ((klass), GLU_TYPE_DISK, glu_disk_class))
#define GLU_IS_DISK(object)		        (OGLTK_CHECK_TYPE ((object),      GLU_TYPE_DISK))
#define GLU_IS_DISK_CLASS(klass)	    (OGLTK_CHECK_CLASS_TYPE ((klass), GLU_TYPE_DISK))
#define	GLU_DISK_GET_CLASS(object)      (OGLTK_CHECK_GET_CLASS ((object), GLU_TYPE_DISK, glu_disk_class))

typedef struct _glu_disk	            glu_disk;
typedef struct _glu_disk_class          glu_disk_class;

struct _glu_disk
{
    glo_gluquad             parent_instance;
    gdouble                 inner;
    gdouble                 outer;
    gint                    slices;
    gint                    loops;
};

struct _glu_disk_class
{
    glo_gluquad_class       parent_class;
};

GType                       glu_disk_get_type(void);

GLobject*                   glu_disk_new(gdouble inner, gdouble outer, gint slices, gint loops);

gboolean                    glu_disk_set_inner_radius(glu_disk *disk, gdouble inner);
gboolean                    glu_disk_set_outer_radius(glu_disk *disk, gdouble outer);
gboolean                    glu_disk_set_slices(glu_disk *disk, gint slices);
gboolean                    glu_disk_set_loops(glu_disk *disk, gint loops);
gdouble                     glu_disk_get_inner_radius(glu_disk *disk);
gdouble                     glu_disk_get_outer_radius(glu_disk *disk);
gint                        glu_disk_get_slices(glu_disk *disk);
gint                        glu_disk_get_loops(glu_disk *disk);


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* GLU_DISK_H */ 

