/*
Gtk+ogltk - Gtk+ OpenGL Toolkit

Copyright (C) 2003 SandorLabs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Contact :
    John Kiss - jkiss@sandorapplications.com


*/
#if !defined(OGLTK_LIGHTBULB_H)
#define OGLTK_LIGHTBULB_H

#include "ogltk/lightsource.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define	OGLTK_TYPE_LIGHTBULB		            ( ogltk_lightbulb_get_type() )
#define OGLTK_LIGHTBULB(object)		            (G_TYPE_CHECK_INSTANCE_CAST ((object), OGLTK_TYPE_LIGHTBULB, ogltk_lightbulb))
#define OGLTK_LIGHTBULB_CLASS(klass)		    (G_TYPE_CHECK_CLASS_CAST    ((klass),  OGLTK_TYPE_LIGHTBULB, ogltk_lightbulb_class))
#define OGLTK_IS_LIGHTBULB(object)		        (G_TYPE_CHECK_INSTANCE_TYPE ((object), OGLTK_TYPE_LIGHTBULB))
#define OGLTK_IS_LIGHTBULB_CLASS(klass)	        (G_TYPE_CHECK_CLASS_TYPE    ((klass),  OGLTK_TYPE_LIGHTBULB))
#define	OGLTK_LIGHTBULB_GET_CLASS(object)       (G_TYPE_INSTANCE_GET_CLASS  ((object), OGLTK_TYPE_LIGHTBULB, ogltk_lightbulb_class))

typedef struct _ogltk_lightbulb	                ogltk_lightbulb;
typedef struct _ogltk_lightbulb_class           ogltk_lightbulb_class;

struct _ogltk_lightbulb
{
    ogltk_lightsource       parent_instance;
};

struct _ogltk_lightbulb_class
{
  ogltk_lightsource_class   parent_class;

};

GType                       ogltk_lightbulb_get_type(void);

ogltk_lightsource*          ogltk_lightbulb_new(OgltkLightSource source, gfloat x, gfloat y, gfloat z);


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* OGLTK_LIGHTBULB_H */ 

