/*
Gtk+ogltk - Gtk+ OpenGL Toolkit

Copyright (C) 2003 SandorLabs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Contact :
    John Kiss - jkiss@sandorapplications.com


*/
#if !defined(GLT_MATRIX_H)
#define GLT_MATRIX_H

#include "ogltk/ogltk.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


typedef struct _glt_coordinates     gltTranslate;
typedef struct _glt_rotation        gltRotate;   
typedef struct _glt_coordinates     gltCoord; 
  

struct _glt_coordinates
{
    gfloat      x;
    gfloat      y;
    gfloat      z;    
};

struct _glt_rotation
{
    gboolean    set;
    gfloat      angle;
    gfloat      x;
    gfloat      y;
    gfloat      z;    
};


gboolean                    glt_coordinate_set_x(gltCoord *coord, gfloat x);
gboolean                    glt_coordinate_set_y(gltCoord *coord, gfloat y);
gboolean                    glt_coordinate_set_z(gltCoord *coord, gfloat z);

gfloat                      glt_coordinate_get_x(gltCoord *coord);
gfloat                      glt_coordinate_get_y(gltCoord *coord);
gfloat                      glt_coordinate_get_z(gltCoord *coord);

gboolean                    glt_rotate_enable   (gltRotate* rotate, gboolean enable);
gboolean                    glt_rotate_set_angle(gltRotate* rotate, gfloat angle);
gboolean                    glt_rotate_set_x(gltRotate* rotate, gfloat x);
gboolean                    glt_rotate_set_y(gltRotate* rotate, gfloat y);
gboolean                    glt_rotate_set_z(gltRotate* rotate, gfloat z);

gboolean                    glt_rotate_is_enabled(gltRotate* rotate);
gfloat                      glt_rotate_get_angle (gltRotate* rotate);
gfloat                      glt_rotate_get_x(gltRotate* rotate);
gfloat                      glt_rotate_get_y(gltRotate* rotate);
gfloat                      glt_rotate_get_z(gltRotate* rotate);



#define glt_translate_set_x(o,x)    glt_coordinate_set_x((gltCoord*)o,x)
#define glt_translate_set_y(o,x)    glt_coordinate_set_y((gltCoord*)o,x)
#define glt_translate_set_z(o,x)    glt_coordinate_set_z((gltCoord*)o,x)

#define glt_translate_get_x(o)      glt_coordinate_get_x((gltCoord*)o)
#define glt_translate_get_y(o)      glt_coordinate_get_y((gltCoord*)o)
#define glt_translate_get_z(o)      glt_coordinate_get_z((gltCoord*)o)


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* GLT_MATRIX_H */
