/*
Gtk+ogltk - Gtk+ OpenGL Toolkit

Copyright (C) 2003 SandorLabs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Contact :
    John Kiss - jkiss@sandorapplications.com


*/
#if !defined(OGLTK_VIEW2D_H)
#define OGLTK_VIEW2D_H
#include <gdk/gdkglconfig.h>

#include "ogltk/view.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define	OGLTK_TYPE_VIEW2D			            ( ogltk_view2D_get_type() )
#define OGLTK_VIEW2D(object)		            (OGLTK_CHECK_CAST ((object),      OGLTK_TYPE_VIEW2D, ogltk_view2D))
#define OGLTK_VIEW2D_CLASS(klass)		        (OGLTK_CHECK_CLASS_CAST ((klass), OGLTK_TYPE_VIEW2D, ogltk_view2D_class))
#define OGLTK_IS_VIEW2D(object)		            (OGLTK_CHECK_TYPE ((object),      OGLTK_TYPE_VIEW2D))
#define OGLTK_IS_VIEW2D_CLASS(klass)	        (OGLTK_CHECK_CLASS_TYPE ((klass), OGLTK_TYPE_VIEW2D))
#define	OGLTK_VIEW2D_GET_CLASS(object)	        (OGLTK_CHECK_GET_CLASS ((object), OGLTK_TYPE_VIEW2D, ogltk_view2D_class))

typedef struct _ogltk_view2D	                ogltk_view2D;
typedef struct _ogltk_view2D_class              ogltk_view2D_class;

struct _ogltk_view2D
{
    ogltk_view              parent_instance;
    
    gfloat                  orth_near;
    gfloat                  orth_far;
    
    gfloat                  view_ratio;
    
};


struct _ogltk_view2D_class
{
  ogltk_view_class          parent_class;

};

GType                       ogltk_view2D_get_type (void);

GtkWidget*                  ogltk_view2D_new(gboolean direct, OGLTKConfigMode config, OGLTKRenderType render );

gboolean                    ogltk_view2D_set_orth(ogltk_view2D *view2d, gfloat near, gfloat far);
gboolean                    ogltk_view2D_set_ratio(ogltk_view2D *view2d, gfloat ratio);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* OGLTK_VIEW2D_H */
