/*
Gtk+ogltk - Gtk+ OpenGL Toolkit

Copyright (C) 2003 SandorLabs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Contact :
    John Kiss - jkiss@sandorapplications.com


*/
#if !defined(OGLTK_VIEW3D_H)
#define OGLTK_VIEW3D_H
#include <gdk/gdkglconfig.h>

#include "ogltk/view.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define	OGLTK_TYPE_VIEW3D			            ( ogltk_view3D_get_type() )
#define OGLTK_VIEW3D(object)		            (OGLTK_CHECK_CAST ((object),      OGLTK_TYPE_VIEW3D, ogltk_view3D))
#define OGLTK_VIEW3D_CLASS(klass)		        (OGLTK_CHECK_CLASS_CAST ((klass), OGLTK_TYPE_VIEW3D, ogltk_view3D_class))
#define OGLTK_IS_VIEW3D(object)		            (OGLTK_CHECK_TYPE ((object),      OGLTK_TYPE_VIEW3D))
#define OGLTK_IS_VIEW3D_CLASS(klass)	        (OGLTK_CHECK_CLASS_TYPE ((klass), OGLTK_TYPE_VIEW3D))
#define	OGLTK_VIEW3D_GET_CLASS(object)	        (OGLTK_CHECK_GET_CLASS ((object), OGLTK_TYPE_VIEW3D, ogltk_view3D_class))

typedef struct _ogltk_view3D	                ogltk_view3D;
typedef struct _ogltk_view3D_class              ogltk_view3D_class;

struct _ogltk_view3D
{
    ogltk_view              parent_instance;
    gfloat                  per_near;
    gfloat                  per_far;
};


struct _ogltk_view3D_class
{
  ogltk_view_class          parent_class;

};

GType                       ogltk_view3D_get_type (void);

GtkWidget*                  ogltk_view3D_new(gboolean direct, OGLTKConfigMode config, OGLTKRenderType render,gfloat near, gfloat far);
gboolean                    ogltk_view3D_set_perspective(ogltk_view3D *view3d, gfloat near, gfloat far);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* OGLTK_VIEW3D_H */
